求两数之和--LeetCode----(1)

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。

你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。

示例:

给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

首先自己的解法很简答穷举:

class Solution:
    def twoSum(self, nums, target):
        """
        :type nums: List[int]
        :type target: int
        :rtype: List[int]
        """
        for i in range(len(nums)):
            for j in range(1,len(nums)):
                sum = nums[i] + nums[i]
                if sum == target:
                    return i,j
        

穷举法是最容易想到的方法, 之前也写过很多。尤其吃过亏,之前穷举了2000万次的数据,想优化但是优化了半天,速度和没有优化前差不多,超级醉了。之前在牛客网上刷题,也遇到过这种穷举的题,想改进但是还是改不来。今天在LeetCode上,它有官方题解。 自己写完,看了看参考,发现了hashmap---哈希表。的解法,以空间换时间。 减少了一个循环。速度自己上来了。

 

在python中,hashmap相当于就是字典 dict = {},代码如下:

class Solution:
    def twoSum(self, nums, target):
        """
        :type nums: List[int]
        :type target: int
        :rtype: List[int]
        """
        hashmap = {}
        for k ,v in enumerate(nums):  # 通过枚举
            a_num = target -v
            if a_num in hashmap:
                return [hashmap[a_num],k]
            hashmap[v] = k
        return None 

方法二: 也可以不用enumerate

class Solution:
    def twoSum(self, nums, target):
        """
        :type nums: List[int]
        :type target: int
        :rtype: List[int]
        """
        hashmap = {}
        for i in range(len(nums)):
            another_num = target- nums[i]
            if another_num in hashmap:
                return hashmap[another_num],i
            hashmap[nums[i]] = i
        return None

总结:

看似很简单的一个题,对于我来说,掌握了一种新的方法, 也算是查漏补缺吧。

 

 

 

 

 

评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值